/*
   Class Name:

      CPBuffer.

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      This class represents a P Buffer that can be rendered to.
*/


#ifndef CPBUFFER_H
#define CPBUFFER_H

#include<windows.h>
#include<gl/gl.h>
#include<gl/glu.h>
#include<gl/glext.h>
#include<gl/wglext.h>

// PBuffer functions.
extern PFNWGLGETEXTENSIONSSTRINGARBPROC wglGetExtensionsStringARB;

extern PFNWGLCREATEPBUFFERARBPROC wglCreatePbufferARB;
extern PFNWGLGETPBUFFERDCARBPROC wglGetPbufferDCARB;
extern PFNWGLRELEASEPBUFFERDCARBPROC wglReleasePbufferDCARB;
extern PFNWGLDESTROYPBUFFERARBPROC wglDestroyPbufferARB;
extern PFNWGLQUERYPBUFFERARBPROC wglQueryPbufferARB;

extern PFNWGLGETPIXELFORMATATTRIBIVARBPROC wglGetPixelFormatAttribivARB;
extern PFNWGLGETPIXELFORMATATTRIBFVARBPROC wglGetPixelFormatAttribfvARB;
extern PFNWGLCHOOSEPIXELFORMATARBPROC wglChoosePixelFormatARB;

// WGL_ARB_render_texture
extern PFNWGLBINDTEXIMAGEARBPROC wglBindTexImageARB;
extern PFNWGLRELEASETEXIMAGEARBPROC wglReleaseTexImageARB;

bool SetupPBufferARB();
bool SetupRenderTexARB();
bool ExtensionSupported(char *ext);
bool WGLExtensionSupported(char *ext);


class CPBuffer
{
   public:
      CPBuffer();                         // Constructor.
      ~CPBuffer();                        // Destructor.
      bool Initialize(int w, int h,
                      const int *iAttriList,
                      const float *fAttriList,
                      const int *flags);  // Initialize the p buffer for rendering.

      bool MakeCurrent();                 // Used to make the p buffer the current target.
      void Shutdown();                    // Release all resources.

      int width;                          // Width of the p buffer area.
      int height;                         // Height of the p buffer area.
      HPBUFFERARB pBufferHandle;          // Handle to the p buffer.
      HGLRC hRC;                          // P buffer's rendering context.
      HDC hDC;                            // P buffer's device context.
      unsigned int ID;                    // OpenGL ID used to create a texture.
};

#endif


// Copyright December 2004
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com